VERSION 5.00
Begin VB.Form Form1 
   Caption         =   " Data Collection Example"
   ClientHeight    =   4632
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   7032
   LinkTopic       =   "Form1"
   ScaleHeight     =   4632
   ScaleWidth      =   7032
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "Recipient Details"
      Height          =   2532
      Left            =   3480
      TabIndex        =   8
      Top             =   120
      Width           =   3252
      Begin VB.TextBox TextboxRecipAdd 
         Height          =   1572
         Left            =   120
         MultiLine       =   -1  'True
         TabIndex        =   10
         Text            =   "Form1.frx":0000
         Top             =   720
         Width           =   2892
      End
      Begin VB.ComboBox ComboRecipName 
         Height          =   288
         Left            =   120
         TabIndex        =   9
         Text            =   "Click Here and Type A B or C"
         Top             =   240
         Width           =   2892
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "User Details"
      Height          =   4332
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   3012
      Begin VB.TextBox TextBoxUserName 
         Height          =   372
         Left            =   120
         TabIndex        =   7
         Text            =   "Click Here and Type C or F"
         Top             =   240
         Width           =   2652
      End
      Begin VB.TextBox TextBoxUserRef 
         Height          =   372
         Left            =   120
         TabIndex        =   6
         Text            =   "User Ref"
         Top             =   840
         Width           =   2652
      End
      Begin VB.TextBox TextBoxDocSig 
         Height          =   852
         Left            =   120
         MultiLine       =   -1  'True
         TabIndex        =   5
         Text            =   "Form1.frx":0012
         Top             =   3240
         Width           =   2652
      End
      Begin VB.TextBox TextBoxUserFax 
         Height          =   372
         Left            =   120
         TabIndex        =   4
         Text            =   "User Fax"
         Top             =   2040
         Width           =   2652
      End
      Begin VB.TextBox TextBoxUserEMail 
         Height          =   372
         Left            =   120
         TabIndex        =   3
         Text            =   "User Email"
         Top             =   2640
         Width           =   2652
      End
      Begin VB.TextBox TextBoxUserTel 
         Height          =   372
         Left            =   120
         TabIndex        =   2
         Text            =   "User Tel"
         Top             =   1440
         Width           =   2652
      End
   End
   Begin VB.CommandButton CMDSaveAndExit 
      Caption         =   "Save And Exit"
      Height          =   372
      Left            =   3480
      TabIndex        =   0
      Top             =   2880
      Width           =   3252
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim Counter As Integer
Dim CountRec As Integer
Dim SaveDoc As String

Dim DatabaseToOpen As String
Dim MyWorkspace As Workspace
Dim dbs As Database
Dim rst As Recordset
Dim varRecords As Variant

Private Type RecType
    Name As String
    Ref As String
    Phone As Integer
    Fax As Integer
    EMail As String
    DocSignature As String
    FaxSignature As String
    MemoSignature As String
    MemoDivision As String
    ManagerName As String
    ManagerTitle As String
End Type

Dim ArrayOfRecs() As RecType


Sub FormatTextBoxText(A As String, ThisBox As TextBox)
' restores carriage returns and line feeds when reading in from text file using  as the delimeter
Dim L, i As Integer
Dim P&
Dim t$

'first clear text box
ThisBox.Text = ""

L = Len(A$)
        
        
        For i = 1 To L
            P& = InStr(i, A$, "")
                If P& = 0 Then Exit For
            t$ = Mid$(A$, i, P& - i)
            ThisBox = ThisBox & t$ & Chr$(13) & Chr$(10)
            i = P&
        Next i
        
        t$ = Mid(A$, i, L - P&)
        ThisBox = ThisBox & t$
End Sub

Private Sub CMDSaveAndExit_Click()
    
    On Error Resume Next
    Dim Found As Integer
     ' loop through array looking for user name
     For CountRec = 1 To Counter
        If InStr(ArrayOfRecs(CountRec).Name, TextBoxUserName.Text) Then
            Found = 1
            Exit For
        End If
    Next
    
    
    

    
     ' loop through array looking for user name
    For CountRec = 1 To Counter
        If InStr(ArrayOfRecs(CountRec).Name, TextBoxUserName.Text) Then
            Found = 1
            Exit For
        End If
    Next
    
    If Found Then
        ' If found update array with text box contents
        ArrayOfRecs(CountRec).Ref = TextBoxUserRef.Text
        ArrayOfRecs(CountRec).Phone = Val(TextBoxUserTel.Text)
        ArrayOfRecs(CountRec).Fax = Val(TextBoxUserFax.Text)
        ArrayOfRecs(CountRec).EMail = TextBoxUserEMail.Text
        ArrayOfRecs(CountRec).DocSignature = TextBoxDocSig.Text
        ' not used in this document
        'ArrayOfRecs(CountRec).FaxSignature = ArrayOfRecs(CountRec).FaxSignature
        'ArrayOfRecs(CountRec).MemoSignature = ArrayOfRecs(CountRec).MemoSignature
        'ArrayOfRecs(CountRec).MemoDivision = ArrayOfRecs(CountRec).MemoDivision
        'ArrayOfRecs(CountRec).ManagerName = ArrayOfRecs(CountRec).ManagerName
        'ArrayOfRecs(CountRec).ManagerTitle = ArrayOfRecs(CountRec).ManagerTitle
    Else
        ' increment counter by one to allow for new item in the array
        Counter = Counter + 1
        ' preserve contents of existing array and add extra item
        ReDim Preserve ArrayOfRecs(1 To Counter)
        ArrayOfRecs(Counter).Name = TextBoxUserName.Text
        ArrayOfRecs(Counter).Ref = TextBoxUserRef.Text
        ArrayOfRecs(Counter).Phone = Val(TextBoxUserTel.Text)
        ArrayOfRecs(Counter).Fax = Val(TextBoxUserFax.Text)
        ArrayOfRecs(Counter).EMail = TextBoxUserEMail.Text
        ArrayOfRecs(Counter).DocSignature = TextBoxDocSig.Text
        ' Not Used in This Document
        'ArrayOfRecs(Counter).FaxSignature = TextBoxFaxSig.Text
        'ArrayOfRecs(Counter).MemoSignature = TextBoxMemoSig.Text
        'ArrayOfRecs(Counter).MemoDivision = TextBoxUserDiv.Text
        'ArrayOfRecs(Counter).ManagerName = TextBoxManagerName.Text
        'ArrayOfRecs(Counter).ManagerTitle = TextBoxManagerTitle.Text
    End If
    
    'write out the array to text file SaveDoc
    
    Dim FileNum As Integer
    FileNum% = FreeFile
    Open SaveDoc For Output Shared As FileNum%
    For CountRec = 1 To Counter
        Write #FileNum%, _
        ArrayOfRecs(CountRec).Name, _
        ArrayOfRecs(CountRec).Ref, _
        ArrayOfRecs(CountRec).Phone, _
        ArrayOfRecs(CountRec).Fax, _
        ArrayOfRecs(CountRec).EMail, _
        FormatMultiLineTextBox(ArrayOfRecs(CountRec).DocSignature), _
        FormatMultiLineTextBox(ArrayOfRecs(CountRec).FaxSignature), _
        FormatMultiLineTextBox(ArrayOfRecs(CountRec).MemoSignature), _
        FormatMultiLineTextBox(ArrayOfRecs(CountRec).MemoDivision), _
        ArrayOfRecs(CountRec).ManagerName, _
        FormatMultiLineTextBox(ArrayOfRecs(CountRec).ManagerTitle)
    Next
    Close FileNum%
    
    'update database with combo contents
    SaveRecipientDatabase
    
    
    End
End Sub





Private Sub ComboRecipName_Click()
If Not IsNull(varRecords(1, ComboRecipName.ListIndex)) Then
            FormatTextBoxText CStr(varRecords(1, ComboRecipName.ListIndex)), TextboxRecipAdd
        Else
             TextboxRecipAdd.Text = ""
        End If
End Sub

Private Sub Form_Load()

       
   
    
    Dim FileNum As Integer
    Dim TextLine As String
    
    ' set path for text file and Access database
    SaveDoc = App.Path & "\MEDC Document User Details.txt"
    DatabaseToOpen = App.Path & "\" & "MEDC Document Data.mdb"
    
    
    FileNum% = FreeFile
    Counter = 0
    ' open document and fill array with contents
    Open SaveDoc For Input Shared As FileNum%
    Do While Not EOF(FileNum%)
        Line Input #FileNum%, TextLine
        Counter = Counter + 1
    Loop
    
    Seek FileNum%, 1
    
    ReDim ArrayOfRecs(1 To Counter)
    For CountRec = 1 To Counter
        Input #FileNum%, ArrayOfRecs(CountRec).Name, _
        ArrayOfRecs(CountRec).Ref, _
        ArrayOfRecs(CountRec).Phone, _
        ArrayOfRecs(CountRec).Fax, _
        ArrayOfRecs(CountRec).EMail, _
        ArrayOfRecs(CountRec).DocSignature, _
        ArrayOfRecs(CountRec).FaxSignature, _
        ArrayOfRecs(CountRec).MemoSignature, _
        ArrayOfRecs(CountRec).MemoDivision, _
        ArrayOfRecs(CountRec).ManagerName, _
        ArrayOfRecs(CountRec).ManagerTitle
    Next
    Close FileNum%
End Sub

Private Sub ComboRecipName_KeyUp(KeyCode As Integer, Shift As Integer)
    'On Error Resume Next
    Dim LengthText As Integer
    Dim NewText As Integer
    Dim Answer As String
    Dim LeftText As String
    'Get the length of the typed text.
    LengthText = Len(ComboRecipName.Text)
    'Handle Backspace and Delete keys.


    If KeyCode = vbKeyBack Or KeyCode = vbKeyDelete Or KeyCode = 16 Then
        Exit Sub
    Else
        'Set variable to the typed text.
        LeftText = ComboRecipName.Text
        
        
        If LeftText = "" Then
            Answer = ""
        Else
            'If match, set variable to result.
            Answer = QueryRecipientDatabase(LeftText)
        
        End If
        'Get length of result.
        NewText = Len(Answer)
        'If no match, fill Text box with
        'typed characters only.


        If NewText = 0 Then
            ComboRecipName.Text = LeftText
        Else
            'If query returns result,
            'fill Text box with result.
            ComboRecipName.Text = Answer
            'Set cursor to end of typed characters
            ComboRecipName.SelStart = LengthText
            'Select and highlight portion of
            'result text that wasn't typed.
            ComboRecipName.SelLength = Len(Answer) - LengthText
        End If
    End If
End Sub

Private Sub TextBoxUserName_KeyUp(KeyCode As Integer, Shift As Integer)
    On Error Resume Next
    Dim LengthText As Integer
    Dim NewText As Integer
    'Dim CountRec As Integer
    Dim Answer As String
    Dim LeftText As String
    'Get the length of the typed text.
    LengthText = Len(TextBoxUserName)
    
    'Handle Backspace and Delete keys.

   If KeyCode = vbKeyBack Or KeyCode = vbKeyDelete Then
        Exit Sub
    Else
        'Set variable to the typed text.
        LeftText = TextBoxUserName
        
   
        'If match, set variable to result.
            For CountRec = 1 To Counter
                If LCase(Mid(ArrayOfRecs(CountRec).Name, 1, LengthText)) = LCase(TextBoxUserName.Text) Then
                    Answer = ArrayOfRecs(CountRec).Name
                    ' Fill out the text boxes
                    TextBoxUserRef.Text = ArrayOfRecs(CountRec).Ref
                    TextBoxUserTel.Text = ArrayOfRecs(CountRec).Phone
                    TextBoxUserFax.Text = ArrayOfRecs(CountRec).Fax
                    TextBoxUserEMail.Text = ArrayOfRecs(CountRec).EMail
                    
                    TextBoxDocSig.Text = ""
                    FormatTextBoxText ArrayOfRecs(CountRec).DocSignature, TextBoxDocSig
                    Exit For
                End If
            Next
        End If
        'Get length of result.
        NewText = Len(Answer)
        'If no match, fill Text box with
        'typed characters only.


        If NewText = 0 Then
            TextBoxUserName = LeftText
        Else
            'fill Text box with result.
            TextBoxUserName = Answer
            'Set cursor to end of typed characters
            TextBoxUserName.SelStart = LengthText
            'Select and highlight portion of
            'result text that wasn't typed.
            TextBoxUserName.SelLength = Len(Answer) - LengthText
        End If
 End Sub

Private Function FormatMultiLineTextBox(ByVal pMessage As String) As String
' remove carriage returns and line feeds from text box replacing them with 
    Dim lMessage As String
    Dim lCurChar As String
    Dim X As Integer
    
    'cycle through message string
    For X = 1 To Len(pMessage)
        'get the current character
        lCurChar = Mid(pMessage, X, 1)
        'if the current character is not in the removable list,
          
         
        If InStr(Chr$(13), lCurChar) > 0 Then
            ' add  to local message when a return character found
            lMessage = lMessage & ""
        ElseIf InStr(Chr$(10), lCurChar) > 0 Then
            ' add nothing to local message if line feed found
            lMessage = lMessage
        Else
            ' add character to the local message
            lMessage = lMessage & lCurChar
        End If
        
        
    Next X
    FormatMultiLineTextBox = lMessage
End Function

Private Sub TextBoxUserName_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    TextBoxUserName.Text = ""
End Sub

Public Function QueryRecipientDatabase(FindString As String)
' fills combo box if a match is found
    Dim strSQL As String
    Dim X As Integer
    
    Set MyWorkspace = Workspaces(0)
    
    ' Return reference to database.
    Set dbs = MyWorkspace.OpenDatabase(DatabaseToOpen)
    
    
    ' Build SQL statement that returns specified fields.
   
    strSQL = "SELECT [Recipient Data].RecipName, [Recipient Data].RecipAdd From [Recipient Data] Where ((([Recipient Data].RecipName) Like '" & FindString & "*'" & "))ORDER BY [Recipient Data].RecipName;"
    

    ' Open dynaset-type Recordset object.
    Set rst = dbs.OpenRecordset(strSQL)
    
    If rst.RecordCount Then ' Query returned some records
        
        ComboRecipName.Clear ' first clear combo box contents
        
        ' Return all rows into array.
        varRecords = rst.GetRows(rst.RecordCount)
      
        For X = 1 To rst.RecordCount
            'fill combo with records returned by query
            ComboRecipName.AddItem varRecords(0, X - 1)
        Next
        
        ' return first record from query
        QueryRecipientDatabase = varRecords(0, 0)
        ' set combo text to first record
        ComboRecipName.Text = QueryRecipientDatabase
        '  if not null set recip address to first record
        If Not IsNull(varRecords(1, 0)) Then
            FormatTextBoxText CStr(varRecords(1, 0)), TextboxRecipAdd
        Else
             TextboxRecipAdd.Text = ""
        End If
    End If
    
    ' Close Recordset
    rst.Close
    
End Function

Public Sub SaveRecipientDatabase()
' saves data in combo box back to database
    Dim strSQL As String
    Dim X As Integer
    
    Set MyWorkspace = Workspaces(0)
    
    ' Return reference to database.
    Set dbs = MyWorkspace.OpenDatabase(DatabaseToOpen)
    
    
    ' Build SQL statement that returns specified fields.
   
    strSQL = "SELECT [Recipient Data].RecipName, [Recipient Data].RecipAdd From [Recipient Data] Where ((([Recipient Data].RecipName) Like '" & ComboRecipName.Text & "*'" & ") And (([Recipient Data].RecipAdd) Like '" & FormatMultiLineTextBox(TextboxRecipAdd.Text) & "*'" & ")) ORDER BY [Recipient Data].RecipAdd;"

    
    ' Open dynaset-type Recordset object.
    Set rst = dbs.OpenRecordset(strSQL)
    
    If rst.RecordCount Then ' Query returned a record
        With rst
            .Edit
            'match found update existing record in database
            !RecipAdd = FormatMultiLineTextBox(TextboxRecipAdd.Text)
            .Update
        End With
    Else
        With rst ' no match found create new record in database
            .AddNew
            !RECIPNAME = ComboRecipName.Text
            !RecipAdd = FormatMultiLineTextBox(TextboxRecipAdd.Text)
            .Update
        End With
    End If
    
    ' Close Recordset
    rst.Close

    'Delete Recipient Address if it has not been used for a year
    dbs.Execute "DELETE [Recipient Data].RECIPNAME, [Recipient Data].LASTUSED From [Recipient Data] WHERE ((([Recipient Data].LASTUSED)<Date()-365));"

    dbs.Close

End Sub
